.\"	$NetBSD: getgroups.2,v 1.21 2006/10/07 21:03:51 elad Exp $
.\"
.\" Copyright (c) 1983, 1991, 1993
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"     @(#)getgroups.2	8.2 (Berkeley) 4/16/94
.\"
.Dd October 7, 2006
.Dt GETGROUPS 2
.Os
.Sh NAME
.Nm getgroups
.Nd get group access list
.Sh LIBRARY
.Lb libc
.Sh SYNOPSIS
.In unistd.h
.Ft int
.Fn getgroups "int gidsetlen" "gid_t *gidset"
.Sh DESCRIPTION
.Fn getgroups
gets the current group access list of the current user process
and stores it in the array
.Fa gidset .
The parameter
.Fa gidsetlen
indicates the number of entries that may be placed in
.Fa gidset .
.Fn getgroups
returns the actual number of groups returned in
.Fa gidset .
No more than
.Dv {NGROUPS_MAX}
will ever
be returned.
If
.Fa gidsetlen
is 0,
.Fn getgroups
returns the number of groups without modifying the
.Fa gidset
array.
.Pp
This system call only returns the secondary groups.
.Sh RETURN VALUES
A successful call returns the number of groups in the group set.
A value of \-1 indicates that an error occurred, and the error
code is stored in the global variable
.Va errno .
.Sh ERRORS
The possible errors for
.Fn getgroups
are:
.Bl -tag -width Er
.It Bq Er EINVAL
The argument
.Fa gidsetlen
is non-zero and is smaller than the number of groups in the group set.
.It Bq Er EFAULT
The argument
.Fa gidset
specifies
an invalid address.
.El
.Sh SEE ALSO
.Xr getegid 2 ,
.Xr getgid 2 ,
.Xr setgroups 2 ,
.Xr initgroups 3
.Sh STANDARDS
The
.Fn getgroups
function conforms to
.St -p1003.1-90 .
.Sh HISTORY
The
.Fn getgroups
function call appeared in
.Bx 4.2 .
